<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070801;12045900">
	<META NAME="CHANGED" CONTENT="20070803;14295500">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>User Control Parse </B></FONT>
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#Introduction|outline"><U>Introduction</U></A><A HREF="#How to Open User Control Parse Window|outline"><BR></A><A HREF="#Example with Restricted Grammar|outline"><U>Example
with Restricted Grammar</U></A><A HREF="#How to Open User Control Parse Window|outline"><BR></A><A HREF="#Example with Unrestricted Grammar|outline"><U>Example
with Unrestricted Grammar</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Introduction|outline"></A>
Introduction</H2>
<P STYLE="margin-bottom: 0in">In the previous version of JFLAP, the
user had no control over how to derive a certain string given a
grammar. The user relied on a Brute Force Parse to ascertain whether
the string is accepted or not by the grammar. In addition, the Brute
Force Parse only showed one derivation or parse tree for the input
string.</P>
<P STYLE="margin-bottom: 0in">With User Control Parse, the user can
now select which productions to apply and perform parsing.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Example with Restricted Grammar|outline"></A>
Example with Restricted Grammar</H2>
<P>We will begin by loading the grammar that we entered in the
previous tutorial. You can either enter the grammar (shown below) or
load the file <A HREF="restrictedGrammar.jff">restrictedGrammar.jff</A>.
</P>
<P><BR><BR>
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/example1_0.png" NAME="Graphic0" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P><BR><BR>
</P>
<P>Then you can click on <B>Input,</B> followed by <B>User Control
Parse</B>. After clicking <B>User Control Parse</B>, you should see a
window that is very similar to <B>Brute Force Parse</B> window.</P>
<P><BR><BR>
</P>
<P ALIGN=CENTER><A NAME="editor1"></A><IMG SRC="images/example1_1.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now you can input a string
and try to derive that string by choosing the production rules. Enter
the string “aababb”. Then either click <B>Start</B> or press
<B>Enter key.</B> The root node <B>S</B> will be drawn in the tree
panel. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now click on the rule that
you want to apply. Let's apply production “S-&gt;aSSb”. Click on
the production “S-&gt;aSSb” from the left pane. Notice that you
can now click on <B>Step. </B>After clicking <B>Step</B>, your window
should look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE</B>: Notice that at
the bottom of the window there is a message, “Derived current
String using S-&gt;aSSb production”. This message tells us about
the last production that was applied.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now there are two variables
“<B>S” </B>in our leaves. If we do not specify which <B>S </B>we
are going to apply the next S-production, the error message will pop
up.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Suppose we want to apply the
production “S-&gt;Bb” to the first <B>S</B>. We can specify which
<B>S</B> we are going to apply the rules by clicking the leftmost
variable S in the string “aSSB” at the bottom of the pane.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">We can
simply click on the leftmost <B>S</B> and click on the production
rule “S-&gt;Bb”. Then click <B>Step.</B> Now, we have applied our
desired production to the first <B>S</B> in our string. Your window
should now look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, if we want to apply the
production “B-&gt;a” to the variable “B”, we can click on
this production and click <B>Step</B>. There is no need to specify
which <B>B </B>to apply the production, since there is only one <B>B
</B><SPAN STYLE="font-weight: medium">in the string “aBbSb”</SPAN>.
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">You can go back to previous
steps, by clicking on <B>Previous</B>. Click <B>Previous</B>, now we
are back at our previous step with string “aSSb”. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Suppose we want to apply the
same production to both of the <B>S</B><SPAN STYLE="font-weight: medium">
variables in “aSSb”</SPAN>. We can achieve this by clicking both
<B>S</B> variables at the bottom of the panel, then select a single
production rule “S-&gt;Bb”. Then click <B>Step. </B><SPAN STYLE="font-weight: medium">In
this case, the two productions are applied left to right, but only
the final result is shown.</SPAN></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE</B>: When you
select multiple items in the bottom of the panel, you just simply
need to click. There is no need for Ctrl+click. If you want to
unselect the item, simply click that item again and it would be
unselected.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">Our new
tree should look like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After applying the
production “B-&gt;a” to both <B>B </B>variables, we can derive
our input string. The final screen should look like one of these : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_6.png" NAME="Graphic10" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_7.png" NAME="Graphic11" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Example with Unrestricted Grammar|outline"></A>
Example with Unrestricted Grammar</H2>
<P>We will begin by loading the grammar that we entered in the
previous tutorial. You can either enter the grammar (shown in <B>Brutoe
Force Parse – Unrestricted Grammar </B>tutorial) or load the file
<A HREF="unrestrictedGrammar.jff">unrestrictedGrammar.jff</A>. After
clicking <B>User Control Parse, </B>you can enter the string “aabbcc”
to parse. Your window should look like this : 
</P>
<P><BR><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example2_1.png" NAME="Graphic12" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P><BR><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now we are going to apply
three productions, “S-&gt;AX”, “A-&gt;aAbc”, “A-&gt;aBbc”.
Click each productions one at a time and click <B>Step</B>. After
three steps later, your window should look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example2_2.png" NAME="Graphic13" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now suppose we want to apply
the production “Bb-&gt;bB”. Since there is only one “Bb”
present in our current string, “aaBbcbcX”, we can just click on
that production and click <B>Step.</B> However, if there are two or
more “Bb” in the string, we have to specify them by clicking
desired “Bb” on the bottom panel. After clicking “Bb” at the
bottom panel and applying the production “Bb-&gt;bB”. your window
should look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example2_3.png" NAME="Graphic14" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We can continue to apply
more productions to attain the input string. However, those steps are
quite lengthy and it is going to be not included in this tutorial
(final derivations shown in <B>Brute Force Parse – Unrestricted
Grammar </B>tutorial page). 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on User Control Parsing. Thanks for reading!</B></P>
</BODY>
</HTML>